<template>
  <div class="ProjectsTab _tabcontent">
    <tab-simple
      v-model="items"
      :is-tab-active="isTabActive"
      :item-title="'L: open with sublime merge, R: open in sublime'"
      @leftClick="leftClick"
      @rightClick="rightClick"
      @middleClick="middleClick"
      @create="createItem"
      @onTabActive="onTabActive"
      tab-name="projects"
      single-item="project">
      <template slot="controls" slot-scope="prop">
        <i @click="openTerminal(prop.item)" class="fa fa-terminal" aria-hidden="true" title="open in terminal"></i>
        <i @click="openWithVscode(prop.item)" class="fa fa-vc" aria-hidden="true" title="open with VScode">vc</i>
        <i @click="openWithPhpStorm(prop.item)" class="fa fa-ps" aria-hidden="true" title="open with PHPstorm">ps</i>
        <i @click="openFolder(prop.item)" class="fa fa-folder" aria-hidden="true" title="open folder"></i>
        <i @click="renameItem(prop.item)" class="fa fa-pencil-square-o" aria-hidden="true" title="rename project"></i>
        <i @click="deleteItem(prop.item)" class="fa fa-trash" aria-hidden="true" title="delete project"></i>
      </template>
    </tab-simple>
    <input
      :nwworkingdir="startDir"
      @change="onProjectCreate"
      ref="DirSelecter"
      class="DirSelecter"
      type="file"
      nwdirectory >
  </div>
</template>

<script>
import TabSimple from '@/components/ui/TabBar/TabSimple/TabSimple'

export default {
  components: {
    TabSimple
  },
  data() {
    return {
      items: [],
      startDir: '',
      createProjectName: ''
    }
  },
  computed: {
    isTabActive() {
      return this.$parent.active
    },
  },
  mounted() {
    if (this.isTabActive) {
      this.onTabActive()
    }
    if (process.client) {
      this.startDir = os.homedir()
    }
  },
  methods: {
    async onTabActive() {
      if (!this.items.length) {
        const { data } = await this.$axios.get(`/projects/get`)
        this.items = data
      }
    },
    async leftClick(item) {
      await this.$axios.post(`/projects/open/smerge/${item.name}`)
      win.close()
    },
    async rightClick(item) {
      await this.$axios.post(`/projects/open/sublime/${item.name}`)
      win.close()
    },
    async middleClick(item) {
      await this.$axios.post(`/projects/open/sublime/${item.name}`)
    },
    async openFolder(item) {
      await this.$axios.post(`/projects/open/folder/${item.name}`)
      win.close()
    },
    async openWithVscode(item) {
      await this.$axios.post(`/projects/open/vscode/${item.name}`)
      win.close()
    },
    async openWithPhpStorm(item) {
      await this.$axios.post(`/projects/open/phpstorm/${item.name}`)
      win.close()
    },
    async openTerminal(item) {
      await this.$axios.post(`/projects/open/terminal/${item.name}`)
      win.close()
    },
    createItem() {
      this.$prompt(`Create project`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.]+$/,
        inputErrorMessage: 'Invalid project name'
      }).then((data) => {
        this.createProjectName = data.value
        this.$refs.DirSelecter.click()
      }).catch(e => {})
    },
    async onProjectCreate() {
      const selected = this.$refs.DirSelecter.value
      const { data: response } = await this.$axios.post('/projects/save-project', {
        name: this.createProjectName,
        path: selected,
        files: '[]'
      })
      if (response.success) {
        this.$message({
          message: 'Project created',
          type: 'success'
        })
        const { data: projects } = await this.$axios.get(`/projects/get`)
        this.items = projects
      } else {
        this.$message.error('Project create error')
      }
    },
    renameItem(item) {
      this.$prompt(`Rename "${item.name}" project to:`, '', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        inputPattern: /^[^\\\/\:\*\?\"\<\>\|\.]+$/,
        inputErrorMessage: 'Invalid project name'
      }).then(async (data) => {
        const newProjectName = data.value
        if (newProjectName && newProjectName !== item.name) {
          await this.$axios.post(`/projects/rename/${item.name}`, {
            newName: data.value
          })
          const index = _.findIndex(this.items, { name: item.name })
          this.items.splice(index, 1, { name: newProjectName })
        }
      }).catch(e => {})
    },
    deleteItem(item) {
      this.$confirm(`Delete project ${item.name}. Continue?`, 'Warning', {
        confirmButtonText: 'OK',
        cancelButtonText: 'Cancel',
        type: 'warning'
      }).then(async () => {
        await this.$axios.post(`/projects/delete/${item.name}`)
        const index = _.findIndex(this.items, { name: item.name })
        this.items.splice(index, 1)
      })
    },
  }
}
</script>

<style lang="less" scoped>
@import "./ProjectsTab.less";
</style>